package nsdb;

/** stream-based skeleton class */

public abstract class LocationPOA
	extends org.omg.PortableServer.Servant
	implements org.omg.CORBA.portable.InvokeHandler, nsdb.LocationOperations
{
	static private final java.util.Hashtable m_opsHash = new java.util.Hashtable();
	static
	{
		m_opsHash.put ( "getNodes", new java.lang.Integer(0));
		m_opsHash.put ( "getLocationString", new java.lang.Integer(1));
		m_opsHash.put ( "getSeq", new java.lang.Integer(2));
	}
	private String[] ids = {"IDL:nsdb/Location:1.0"};
	public nsdb.Location _this()
	{
		return nsdb.LocationHelper.narrow(_this_object());
	}
	public nsdb.Location _this(org.omg.CORBA.ORB orb)
	{
		return nsdb.LocationHelper.narrow(_this_object(orb));
	}
	public org.omg.CORBA.portable.OutputStream _invoke(String method, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.ResponseHandler handler)
		throws org.omg.CORBA.SystemException
	{
		org.omg.CORBA.portable.OutputStream _out = null;
		// do something
		// quick lookup of operation
		java.lang.Integer opsIndex = (java.lang.Integer)m_opsHash.get ( method );
		if ( null == opsIndex )
			throw new org.omg.CORBA.BAD_OPERATION(method + " not found");
		switch ( opsIndex.intValue() )
		{
			case 0: // getNodes
			{
				_out = handler.createReply();
				nsdb.LocationPackage.LocationNodeListHelper.write(_out,getNodes());
				break;
			}
			case 1: // getLocationString
			{
				_out = handler.createReply();
				_out.write_string(getLocationString());
				break;
			}
			case 2: // getSeq
			{
			try
			{
				_out = handler.createReply();
				_out.write_string(getSeq());
			}
			catch(nsdb.InexactLocation _ex0)
			{
				_out = handler.createExceptionReply();
				nsdb.InexactLocationHelper.write(_out, _ex0);
			}
				break;
			}
		}
		return _out;
	}

	public String[] _all_interfaces(org.omg.PortableServer.POA poa, byte[] obj_id)
	{
		return ids;
	}
}
